
import 'package:flutter/material.dart';

import 'mtn_money/core/flutterwave.dart';
import 'mtn_money/utils/flutterwave_currency.dart';


// import 'package:flutterwave/flutterwave.dart';

// void main() {
//   runApp(const MyApp());
// }

class MyMtn extends StatelessWidget {
  const MyMtn({Key? key}) : super(key: key);

  @override
  Widget build(BuildContext context) {
    return MaterialApp(
        debugShowCheckedModeBanner: false,
        theme: ThemeData(
          primarySwatch: Colors.green,
        ),
        home: const HomePage());
  }
}

class HomePage extends StatefulWidget {
  const HomePage({Key? key}) : super(key: key);

  @override
  HomePageState createState() => HomePageState();
}

class HomePageState extends State<HomePage> {






  String? currency;
  //use the currency you would like the use to Pay In, in this case used KES currency
  @override

  // void initState() {
  //
  //   super.initState();
  //
  //   if(dropdownValue == "NGN"){  currency = FlutterwaveCurrency.NGN;}
  //   else if(dropdownValue == "KES"){currency = FlutterwaveCurrency.KES;}
  //   else if(dropdownValue == "RWF"){ currency = FlutterwaveCurrency.RWF;}
  //   else if(dropdownValue == "UGX"){ currency = FlutterwaveCurrency.UGX;}
  //   else if(dropdownValue == "ZMW"){currency = FlutterwaveCurrency.ZMW;}
  //   else if(dropdownValue == "GHS"){ currency = FlutterwaveCurrency.GHS;}
  //   else if(dropdownValue == "XOF"){ currency = FlutterwaveCurrency.XOF;}
  //   else if(dropdownValue == "ZAR"){ currency = FlutterwaveCurrency.ZAR;}
  //
  // }
  // final String currency = FlutterwaveCurrency.NGN;



  final formKey = GlobalKey<FormState>();
  final TextEditingController fullname = TextEditingController();
  final TextEditingController phone = TextEditingController();
  final TextEditingController email = TextEditingController();
  final TextEditingController amount = TextEditingController();
  final TextEditingController currencyController = TextEditingController();
  String dropdownValue = 'Select Currency';

  @override
  Widget build(context) {
    return Scaffold(
        appBar: AppBar(
          title: const Text(''),
          centerTitle: true,
        ),
        body: Padding(
            padding: const EdgeInsets.only(top: 10.0),
            child: Form(
                key: formKey,
                child: SingleChildScrollView(
                  child: Column(children: [
                    const Padding(padding: EdgeInsets.all(10.0)),
                    Container(
                      margin: const EdgeInsets.only(bottom: 10),
                      child: TextFormField(
                        controller: fullname,
                        decoration:
                        const InputDecoration(labelText: "Full Name"),
                        validator: (value) => value!.isNotEmpty
                            ? null
                            : "Please fill in Your Name",
                      ),
                    ),
                    Container(
                      margin: const EdgeInsets.only(bottom: 10),
                      child: TextFormField(
                        controller: phone,
                        decoration:
                        const InputDecoration(labelText: "Phone Number"),
                        validator: (value) => value!.isNotEmpty
                            ? null
                            : "Please fill in Your Phone number",
                      ),
                    ),
                    Container(
                      margin: const EdgeInsets.only(bottom: 10),
                      child: TextFormField(
                        controller: email,
                        decoration: const InputDecoration(labelText: "Email"),
                        validator: (value) => value!.isNotEmpty
                            ? null
                            : "Please fill in Your Email",
                      ),
                    ),
                    Container(
                      margin: const EdgeInsets.only(bottom: 10),
                      child: TextFormField(
                        controller: amount,
                        decoration: const InputDecoration(labelText: "Amount"),
                        validator: (value) => value!.isNotEmpty
                            ? null
                            : "Please fill in the Amount you are Paying",
                      ),
                    ),
                    Container(
                      margin: const EdgeInsets.only(bottom: 10),
                      child: DropdownButtonFormField(hint:  Text("Select Currency"),
                        validator: (value) => value == "Select Currency"
                            ? "Please Select Currency"
                            : null,
                        // decoration: const InputDecoration(labelText: "Currency"),

                        value: dropdownValue,
                        onChanged: (String? newValue) {
                          setState(() {
                            dropdownValue = newValue!;

                            if(dropdownValue == "Select Currency"){ return null; }
                            if(dropdownValue == "NGN"){  currency = FlutterwaveCurrency.NGN;}
                            else if(dropdownValue == "KES"){currency = FlutterwaveCurrency.KES;}
                            else if(dropdownValue == "RWF"){ currency = FlutterwaveCurrency.RWF;}
                            else if(dropdownValue == "UGX"){ currency = FlutterwaveCurrency.UGX;}
                            else if(dropdownValue == "ZMW"){currency = FlutterwaveCurrency.ZMW;}
                            else if(dropdownValue == "XAF"){currency = FlutterwaveCurrency.XAF;}
                            else if(dropdownValue == "GHS"){ currency = FlutterwaveCurrency.GHS;}
                            else if(dropdownValue == "XOF"){ currency = FlutterwaveCurrency.XOF;}
                            else if(dropdownValue == "ZAR"){ currency = FlutterwaveCurrency.ZAR;}
                          });

                        },
                        items: <String>[
                          "Select Currency",
                          "RWF",
                          "UGX",
                          "ZMW",
                          "GHS",
                          "XAF",
                          "XOF",

                        ].map<DropdownMenuItem<String>>((String value) {
                          return DropdownMenuItem<String>(
                            value: value,
                            child: Text(
                              value,
                              style: TextStyle(fontSize: 15,color: Colors.grey[700]),
                            ),

                          );
                        }).toList(),
                      ),
                    ),
                    ElevatedButton(
                      child: const Text('Pay'),
                      onPressed: () {
                        final name = fullname.text;
                        final userPhone = phone.text;
                        final userEmail = email.text;
                        final amountPaid = amount.text;

                        if (formKey.currentState!.validate()) {
                          _makeFlutterwavePayment(
                              context, name, userPhone, userEmail, amountPaid);
                        }
                      },
                    ),
                  ]),
                ))));
  }

  //Add a method to make the flutter wave payment
  //This Method includes all the values needed to create the Flutterwave Instance
  void _makeFlutterwavePayment(BuildContext context, String fullname,
      String phone, String email, String amount) async {
    try {
      Flutterwave flutterwave = Flutterwave.forUIPayment(
        //the first 10 fields below are required/mandatory
          context: this.context,
          fullName: fullname,
          phoneNumber: phone,
          email: email,
          amount: amount,
          //Use your Public and Encription Keys from your Flutterwave account on the dashboard
          encryptionKey: "FLWSECK_TEST3bd0078c58e5",
          publicKey: "FLWPUBK_TEST-c1767c7e89cda45c5e10ce334dfe5f9c-X",
          currency: currency.toString(),
          txRef: DateTime.now().toIso8601String(),
          //Setting DebugMode below to true since will be using test mode.
          //You can set it to false when using production environment.
          isDebugMode: true,
          //configure the the type of payments that your business will accept
          acceptCardPayment: false,
          acceptUSSDPayment: false,
          acceptAccountPayment: false,
          acceptFrancophoneMobileMoney: false,
          acceptGhanaPayment: false,
          acceptMpesaPayment: false,
          acceptRwandaMoneyPayment: false,
          acceptUgandaPayment: false,
          acceptZambiaPayment: false);

      final response = await flutterwave.initializeForUiPayments();
      if (response == null) {
        print("Transaction Failed");
      } else {
        if (response.status == "Transaction successful") {
          print(response.data);
          print(response.message);
        } else {
          print(response.message);
        }
      }
    } catch (error) {
      print(error);
    }
  }
}




